package eu.jovian_hersemeule.dev.squad.squad_composer.controllers;

import org.springframework.web.bind.annotation.RestController;
import eu.jovian_hersemeule.dev.squad.squad_composer.data.jpa.SquadEntity;
import eu.jovian_hersemeule.dev.squad.squad_composer.data.projections.SquadItem;
import eu.jovian_hersemeule.dev.squad.squad_composer.data.repos.SquadRepository;

import java.util.List;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;

@RestController
@RequestMapping("/squads")
public class SquadController {

    final private SquadRepository repo;

    SquadController(final SquadRepository squadRepository) {
        this.repo = squadRepository;
    }

    @GetMapping("/")
    public List<SquadItem> list() {
        return repo.findAll().stream().map(SquadItem::project).toList();
    }

    @GetMapping("/{id}")
    public SquadEntity get(@PathVariable final long id) {
        return repo.findById(id).orElseThrow(() -> new RuntimeException("Squad not found"));
    }

}
